# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from qb_chain_msgs/MoveAndRotateChain.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import qb_chain_msgs.msg
import std_msgs.msg

class MoveAndRotateChain(genpy.Message):
  _md5sum = "004f59dd1447f2b7fd1465cd524ec65a"
  _type = "qb_chain_msgs/MoveAndRotateChain"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# message to control end-effector pose, robot sitiffness, velocity and end-effector rotation

qb_chain_msgs/MoveChain move_robot      # control end-effector position, robot sitiffness and velocity
float64 roll                            # end-effector roll

================================================================================
MSG: qb_chain_msgs/MoveChain
# message to control end-effector pose, robot sitiffness and velocity

geometry_msgs/PointStamped target_pose  # target pose in cartesian space
float64[] motor_stiffnesses             # array containing the motors stiffnesses
float64 velocity                        # normalized velocity for moving the robot [0.1, 1]
string type_of_movement                 # type of movement for the robot to reach the target 

================================================================================
MSG: geometry_msgs/PointStamped
# This represents a Point with reference coordinate frame and timestamp
Header header
Point point

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z
"""
  __slots__ = ['move_robot','roll']
  _slot_types = ['qb_chain_msgs/MoveChain','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       move_robot,roll

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MoveAndRotateChain, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.move_robot is None:
        self.move_robot = qb_chain_msgs.msg.MoveChain()
      if self.roll is None:
        self.roll = 0.
    else:
      self.move_robot = qb_chain_msgs.msg.MoveChain()
      self.roll = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.move_robot.target_pose.header.seq, _x.move_robot.target_pose.header.stamp.secs, _x.move_robot.target_pose.header.stamp.nsecs))
      _x = self.move_robot.target_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3d().pack(_x.move_robot.target_pose.point.x, _x.move_robot.target_pose.point.y, _x.move_robot.target_pose.point.z))
      length = len(self.move_robot.motor_stiffnesses)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.move_robot.motor_stiffnesses))
      _x = self.move_robot.velocity
      buff.write(_get_struct_d().pack(_x))
      _x = self.move_robot.type_of_movement
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.roll
      buff.write(_get_struct_d().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.move_robot is None:
        self.move_robot = qb_chain_msgs.msg.MoveChain()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.move_robot.target_pose.header.seq, _x.move_robot.target_pose.header.stamp.secs, _x.move_robot.target_pose.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.move_robot.target_pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.move_robot.target_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.move_robot.target_pose.point.x, _x.move_robot.target_pose.point.y, _x.move_robot.target_pose.point.z,) = _get_struct_3d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.move_robot.motor_stiffnesses = s.unpack(str[start:end])
      start = end
      end += 8
      (self.move_robot.velocity,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.move_robot.type_of_movement = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.move_robot.type_of_movement = str[start:end]
      start = end
      end += 8
      (self.roll,) = _get_struct_d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.move_robot.target_pose.header.seq, _x.move_robot.target_pose.header.stamp.secs, _x.move_robot.target_pose.header.stamp.nsecs))
      _x = self.move_robot.target_pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3d().pack(_x.move_robot.target_pose.point.x, _x.move_robot.target_pose.point.y, _x.move_robot.target_pose.point.z))
      length = len(self.move_robot.motor_stiffnesses)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.move_robot.motor_stiffnesses.tostring())
      _x = self.move_robot.velocity
      buff.write(_get_struct_d().pack(_x))
      _x = self.move_robot.type_of_movement
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.roll
      buff.write(_get_struct_d().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.move_robot is None:
        self.move_robot = qb_chain_msgs.msg.MoveChain()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.move_robot.target_pose.header.seq, _x.move_robot.target_pose.header.stamp.secs, _x.move_robot.target_pose.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.move_robot.target_pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.move_robot.target_pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.move_robot.target_pose.point.x, _x.move_robot.target_pose.point.y, _x.move_robot.target_pose.point.z,) = _get_struct_3d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.move_robot.motor_stiffnesses = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 8
      (self.move_robot.velocity,) = _get_struct_d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.move_robot.type_of_movement = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.move_robot.type_of_movement = str[start:end]
      start = end
      end += 8
      (self.roll,) = _get_struct_d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_d = None
def _get_struct_d():
    global _struct_d
    if _struct_d is None:
        _struct_d = struct.Struct("<d")
    return _struct_d
