// Auto-generated. Do not edit!

// (in-package qb_chain_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let MoveChain = require('./MoveChain.js');

//-----------------------------------------------------------

class MoveAndRotateChain {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.move_robot = null;
      this.roll = null;
    }
    else {
      if (initObj.hasOwnProperty('move_robot')) {
        this.move_robot = initObj.move_robot
      }
      else {
        this.move_robot = new MoveChain();
      }
      if (initObj.hasOwnProperty('roll')) {
        this.roll = initObj.roll
      }
      else {
        this.roll = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MoveAndRotateChain
    // Serialize message field [move_robot]
    bufferOffset = MoveChain.serialize(obj.move_robot, buffer, bufferOffset);
    // Serialize message field [roll]
    bufferOffset = _serializer.float64(obj.roll, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MoveAndRotateChain
    let len;
    let data = new MoveAndRotateChain(null);
    // Deserialize message field [move_robot]
    data.move_robot = MoveChain.deserialize(buffer, bufferOffset);
    // Deserialize message field [roll]
    data.roll = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += MoveChain.getMessageSize(object.move_robot);
    return length + 8;
  }

  static datatype() {
    // Returns string type for a message object
    return 'qb_chain_msgs/MoveAndRotateChain';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '004f59dd1447f2b7fd1465cd524ec65a';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # message to control end-effector pose, robot sitiffness, velocity and end-effector rotation
    
    qb_chain_msgs/MoveChain move_robot      # control end-effector position, robot sitiffness and velocity
    float64 roll                            # end-effector roll
    
    ================================================================================
    MSG: qb_chain_msgs/MoveChain
    # message to control end-effector pose, robot sitiffness and velocity
    
    geometry_msgs/PointStamped target_pose  # target pose in cartesian space
    float64[] motor_stiffnesses             # array containing the motors stiffnesses
    float64 velocity                        # normalized velocity for moving the robot [0.1, 1]
    string type_of_movement                 # type of movement for the robot to reach the target 
    
    ================================================================================
    MSG: geometry_msgs/PointStamped
    # This represents a Point with reference coordinate frame and timestamp
    Header header
    Point point
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MoveAndRotateChain(null);
    if (msg.move_robot !== undefined) {
      resolved.move_robot = MoveChain.Resolve(msg.move_robot)
    }
    else {
      resolved.move_robot = new MoveChain()
    }

    if (msg.roll !== undefined) {
      resolved.roll = msg.roll;
    }
    else {
      resolved.roll = 0.0
    }

    return resolved;
    }
};

module.exports = MoveAndRotateChain;
