// Auto-generated. Do not edit!

// (in-package qb_chain_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class MoveChain {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.target_pose = null;
      this.motor_stiffnesses = null;
      this.velocity = null;
      this.type_of_movement = null;
    }
    else {
      if (initObj.hasOwnProperty('target_pose')) {
        this.target_pose = initObj.target_pose
      }
      else {
        this.target_pose = new geometry_msgs.msg.PointStamped();
      }
      if (initObj.hasOwnProperty('motor_stiffnesses')) {
        this.motor_stiffnesses = initObj.motor_stiffnesses
      }
      else {
        this.motor_stiffnesses = [];
      }
      if (initObj.hasOwnProperty('velocity')) {
        this.velocity = initObj.velocity
      }
      else {
        this.velocity = 0.0;
      }
      if (initObj.hasOwnProperty('type_of_movement')) {
        this.type_of_movement = initObj.type_of_movement
      }
      else {
        this.type_of_movement = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type MoveChain
    // Serialize message field [target_pose]
    bufferOffset = geometry_msgs.msg.PointStamped.serialize(obj.target_pose, buffer, bufferOffset);
    // Serialize message field [motor_stiffnesses]
    bufferOffset = _arraySerializer.float64(obj.motor_stiffnesses, buffer, bufferOffset, null);
    // Serialize message field [velocity]
    bufferOffset = _serializer.float64(obj.velocity, buffer, bufferOffset);
    // Serialize message field [type_of_movement]
    bufferOffset = _serializer.string(obj.type_of_movement, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type MoveChain
    let len;
    let data = new MoveChain(null);
    // Deserialize message field [target_pose]
    data.target_pose = geometry_msgs.msg.PointStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [motor_stiffnesses]
    data.motor_stiffnesses = _arrayDeserializer.float64(buffer, bufferOffset, null)
    // Deserialize message field [velocity]
    data.velocity = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [type_of_movement]
    data.type_of_movement = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += geometry_msgs.msg.PointStamped.getMessageSize(object.target_pose);
    length += 8 * object.motor_stiffnesses.length;
    length += _getByteLength(object.type_of_movement);
    return length + 16;
  }

  static datatype() {
    // Returns string type for a message object
    return 'qb_chain_msgs/MoveChain';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'c2c590bbc6a146c721d998cbfe93c463';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # message to control end-effector pose, robot sitiffness and velocity
    
    geometry_msgs/PointStamped target_pose  # target pose in cartesian space
    float64[] motor_stiffnesses             # array containing the motors stiffnesses
    float64 velocity                        # normalized velocity for moving the robot [0.1, 1]
    string type_of_movement                 # type of movement for the robot to reach the target 
    
    ================================================================================
    MSG: geometry_msgs/PointStamped
    # This represents a Point with reference coordinate frame and timestamp
    Header header
    Point point
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new MoveChain(null);
    if (msg.target_pose !== undefined) {
      resolved.target_pose = geometry_msgs.msg.PointStamped.Resolve(msg.target_pose)
    }
    else {
      resolved.target_pose = new geometry_msgs.msg.PointStamped()
    }

    if (msg.motor_stiffnesses !== undefined) {
      resolved.motor_stiffnesses = msg.motor_stiffnesses;
    }
    else {
      resolved.motor_stiffnesses = []
    }

    if (msg.velocity !== undefined) {
      resolved.velocity = msg.velocity;
    }
    else {
      resolved.velocity = 0.0
    }

    if (msg.type_of_movement !== undefined) {
      resolved.type_of_movement = msg.type_of_movement;
    }
    else {
      resolved.type_of_movement = ''
    }

    return resolved;
    }
};

module.exports = MoveChain;
